<template>
  <section>
    <v-container fluid :style="hero_background" class="py-15">
      <v-row justify="center" align="center" dense>
        <v-col cols="10">
          <!-- Hero: Edición de Título -->
          <v-row fill-height fluid>
            <template v-if="$store.getters['loggedIn']">
              <v-dialog
                v-if="user && user.type === 'superadmin'"
                v-model="hero_dialog"
                transition="dialog-bottom-transition"
                max-width="600"
              >
                <template #activator="{ on, attrs }">
                  <v-btn
                    class="mx-2"
                    fab
                    absolute
                    dark
                    small
                    color="primary"
                    v-bind="attrs"
                    v-on="on"
                    @click="hero_dialog = true"
                  >
                    <v-icon dark>mdi-pencil</v-icon>
                  </v-btn>
                </template>
                <template #default="dialog">
                  <v-card :loading="loading">
                    <template slot="progress">
                      <v-progress-linear
                        color="primary"
                        height="10"
                        indeterminate
                      ></v-progress-linear>
                    </template>
                    <v-toolbar color="primary" dark>{{
                      $t('editor.hero_background_style')
                    }}</v-toolbar>
                    <v-card-text class="mt-3">
                      <v-select
                        v-model="brandSettings.hero_background_type"
                        :items="backgroundTypes"
                        item-text="text"
                        item-value="type"
                        :rules="[
                          (v) => !!v || $t('editor.required_background_type'),
                        ]"
                        solo
                        required
                      ></v-select>
                    </v-card-text>
                    <v-card-text
                      v-if="brandSettings.hero_background_type === 'lineal'"
                    >
                      <v-text-field
                        v-model="brandSettings.hero_bg_primary"
                        :value="brandSettings.hero_bg_primary"
                        prepend-icon="mdi-eyedropper-variant"
                        type="color"
                        :label="$t('editor.select_color')"
                        class="py-0"
                        width="50%"
                      ></v-text-field>
                    </v-card-text>
                    <v-card-text
                      v-if="brandSettings.hero_background_type === 'gradient'"
                    >
                      <v-text-field
                        v-model="brandSettings.hero_bg_primary"
                        :value="brandSettings.hero_bg_primary"
                        prepend-icon="mdi-eyedropper-variant"
                        type="color"
                        :label="$t('editor.select_top_color')"
                        class="py-0"
                        width="50%"
                      ></v-text-field>
                      <v-text-field
                        v-model="brandSettings.hero_bg_secondary"
                        :value="brandSettings.hero_bg_secondary"
                        prepend-icon="mdi-eyedropper-variant"
                        type="color"
                        :label="$t('editor.select_bottom_color')"
                        class="py-0"
                        width="50%"
                      ></v-text-field>
                    </v-card-text>
                    <v-card-text
                      v-if="brandSettings.hero_background_type === 'image'"
                    >
                      <v-card v-if="brandSettings.hero_bg_image">
                        <v-container fluid grid-list-lg>
                          <v-layout row>
                            <v-flex xs12>
                              <img
                                :src="brandSettings.hero_bg_image"
                                width="100%"
                                @error="imageLoadError('hero_bg_image')"
                              />
                              <span v-if="error.hero_bg_image">{{
                                $t('editor.invalid_url')
                              }}</span>
                            </v-flex>
                          </v-layout>
                        </v-container>
                      </v-card>
                      <input
                        v-show="false"
                        id="hero_bg_image"
                        ref="hero_bg_image"
                        type="file"
                        accept="image/*"
                        @change="onFileSelected"
                      />
                      <v-btn
                        block
                        color="primary"
                        :title="$t('editor.upload_image')"
                        @click="$refs.hero_bg_image.click()"
                      >
                        <v-icon left>mdi-cloud-upload</v-icon>
                      </v-btn>
                    </v-card-text>
                    <v-card-actions class="justify-end">
                      <v-btn text color="error" @click="dialog.value = false">{{
                        $t('editor.cancel')
                      }}</v-btn>
                      <v-btn text color="primary" @click="updateBrand">{{
                        $t('editor.save')
                      }}</v-btn>
                    </v-card-actions>
                  </v-card>
                </template>
              </v-dialog>
            </template>
            <v-col md="6" xs="12" align="center" justify="center">
              <template
                v-if="
                  $store.getters['loggedIn'] &&
                  user &&
                  user.type === 'superadmin'
                "
              >
                <v-img
                  max-height="500"
                  max-width="430"
                  contain
                  :src="brandSettings.city_splash_primary"
                  @click="!isEditing && toggleImageInput('editPrimaryImage')"
                ></v-img>
                <v-text-field
                  v-show="editPrimaryImage"
                  v-model="brandSettings.city_splash_primary"
                  class="mt-1"
                  prepend-icon="mdi-image"
                  outline
                  solo
                  dense
                  dark
                  loader-height="4"
                  :loading="loading"
                  disabled
                  @keydown.enter.exact.prevent
                ></v-text-field>
                <v-row v-show="editPrimaryImage" justify="center" class="mt-1">
                  <v-col cols="3">
                    <input
                      v-show="false"
                      id="city_splash_primary"
                      ref="city_splash_primary"
                      type="file"
                      accept="image/*"
                      @change="onFileSelected"
                    />
                    <v-btn
                      block
                      color="primary"
                      :title="$t('editor.upload_image')"
                      @click="$refs.city_splash_primary.click()"
                    >
                      <v-icon>mdi-cloud-upload</v-icon>
                    </v-btn>
                  </v-col>
                  <v-col cols="3">
                    <v-btn
                      block
                      color="primary"
                      :title="$t('editor.restore_image')"
                      @click="restorePrimaryImage"
                    >
                      <v-icon>mdi-backup-restore</v-icon>
                    </v-btn>
                  </v-col>
                  <v-col cols="3">
                    <v-btn
                      block
                      color="primary"
                      :title="$t('editor.cancel_image_edition')"
                      @click="toggleImageInput('editPrimaryImage')"
                    >
                      <v-icon>mdi-window-close</v-icon>
                    </v-btn>
                  </v-col>
                </v-row>
              </template>
              <template v-else>
                <v-img
                  max-height="500"
                  max-width="430"
                  contain
                  :src="brandSettings.city_splash_primary"
                ></v-img>
              </template>
            </v-col>
            <v-col md="6" xs="12" class="d-flex align-content-center flex-wrap">
              <template
                v-if="
                  $store.getters['loggedIn'] &&
                  user &&
                  user.type === 'superadmin'
                "
              >
                <h2
                  v-if="!editTitle"
                  class="font-weight-bold white--text font-poppins hero-title"
                  @click="!isEditing && toggleInput('editTitle', 'title-input')"
                >
                  {{
                    editedTexts.heroSection.title.trim().length !== 0
                      ? editedTexts.heroSection.title
                      : '[Editar Texto]'
                  }}
                </h2>
                <v-text-field
                  v-show="editTitle"
                  ref="title-input"
                  v-model="editedTexts.heroSection.title"
                  solo
                  dense
                  dark
                  loader-height="4"
                  :loading="loading"
                  @keydown.enter.exact.prevent
                  @keyup.enter.exact="updateLandingText"
                  @blur="updateLandingText"
                >
                </v-text-field>
              </template>
              <template v-else>
                <h2
                  class="font-weight-bold white--text font-poppins hero-title"
                >
                  {{ editedTexts.heroSection.title }}
                </h2>
              </template>
              <!-- Hero: Edición de Subtitulo-->
              <v-col cols="12" class="pl-0">
                <template
                  v-if="
                    $store.getters['loggedIn'] &&
                    user &&
                    user.type === 'superadmin'
                  "
                >
                  <h3
                    v-if="!editSubtitle"
                    class="
                      hero-subtitle
                      font-poppins font-weight-medium
                      white--text
                    "
                    @click="
                      !isEditing &&
                        toggleInput('editSubtitle', 'subtitle-input')
                    "
                  >
                    {{
                      editedTexts.heroSection.subtitle.trim().length !== 0
                        ? editedTexts.heroSection.subtitle
                        : '[Editar Texto]'
                    }}
                  </h3>

                  <v-textarea
                    v-show="editSubtitle"
                    ref="subtitle-input"
                    v-model="editedTexts.heroSection.subtitle"
                    solo
                    dense
                    dark
                    loader-height="4"
                    :loading="loading"
                    @keydown.enter.exact.prevent
                    @keyup.enter.exact="updateLandingText"
                    @blur="updateLandingText"
                  />
                </template>
                <template v-else>
                  <h3
                    class="
                      hero-subtitle
                      font-poppins font-weight-medium
                      white--text
                    "
                  >
                    {{ editedTexts.heroSection.subtitle }}
                  </h3>
                </template>
              </v-col>
              <!-- SECOND SUBTITLE -->
              <v-col cols="12" class="pl-0">
                <template
                  v-if="
                    $store.getters['loggedIn'] &&
                    user &&
                    user.type === 'superadmin'
                  "
                >
                  <h3
                    v-if="!editSecondSubtitle"
                    class="
                      hero-second-subtitle
                      font-montserrat font-weight-regular
                      white--text
                      my-5
                    "
                    @click="
                      !isEditing &&
                        toggleInput(
                          'editSecondSubtitle',
                          'second-subtitle-input'
                        )
                    "
                  >
                    {{
                      editedTexts.heroSection.second_subtitle.trim().length !==
                      0
                        ? editedTexts.heroSection.second_subtitle
                        : '[Editar Texto]'
                    }}
                  </h3>

                  <v-textarea
                    v-show="editSecondSubtitle"
                    ref="second-subtitle-input"
                    v-model="editedTexts.heroSection.second_subtitle"
                    solo
                    dense
                    dark
                    loader-height="4"
                    :loading="loading"
                    @keydown.enter.exact.prevent
                    @keyup.enter.exact="updateLandingText"
                    @blur="updateLandingText"
                  />
                </template>
                <template v-else>
                  <h3
                    class="
                      hero-subtitle
                      font-montserrat font-weight-regular
                      white--text
                      my-5
                    "
                  >
                    {{ editedTexts.heroSection.second_subtitle }}
                  </h3>
                </template>
              </v-col>

              <!-- <v-btn
              v-if="!isUnicef"

              outlined
              x-large
              class="hero-button font-poppins px-14 mt-5"
              color="white"
              d-block
              style="text-transform: none"
            >
              {{ editedTexts.heroSection.button }}
            </v-btn>
            -->
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-container>
    <v-container fluid class="pb-12 mt-8">
      <v-row justify="center" align="center" class="mt-5">
        <v-col cols="12" class="text-center">
          <!-- ColumnSection: Edición de Slogan -->
          <template
            v-if="
              $store.getters['loggedIn'] && user && user.type === 'superadmin'
            "
          >
            <h6
              v-if="!editCitySlogan"
              class="columnSection-slogan font-montserrat font-weight-bold"
              color="primary"
              @click="
                !isEditing && toggleInput('editCitySlogan', 'city-slogan-input')
              "
            >
              {{
                editedTexts.columnsSection.slogan.trim().length !== 0
                  ? editedTexts.columnsSection.slogan
                  : '[Editar Texto]'
              }}
            </h6>
            <v-row align="center" justify="center">
              <v-col md="4">
                <v-text-field
                  v-show="editCitySlogan"
                  ref="city-slogan-input"
                  v-model="editedTexts.columnsSection.slogan"
                  solo
                  loader-height="6"
                  dense
                  dark
                  :loading="loading"
                  @keydown.enter.exact.prevent
                  @keyup.enter.exact="updateLandingText"
                  @blur="updateLandingText"
                />
              </v-col>
            </v-row>
          </template>
          <template v-else>
            <h6 class="columnSection-slogan font-montserrat font-weight-bold">
              {{ editedTexts.columnsSection.slogan }}
            </h6>
          </template>
        </v-col>
      </v-row>
      <v-row class="mt-10" justify="center">
        <!-- <v-col cols="12" sm="10" md="11" lg="12">
        <v-row justify="center"> -->
        <v-col cols="12" md="4" class="mx-md-0">
          <!-- ColumnSection: Edición de Titulo Columna 1 -->
          <v-card
            elevation="7"
            class="mx-lg-5 px-md-12 py-10 px-8 rounded-xl d-flex flex-column"
            height="100%"
          >
            <h2 class="text-center mb-3">
              <v-icon size="70"> $vuetify.icons.oscity_identidad </v-icon>
            </h2>
            <template
              v-if="
                $store.getters['loggedIn'] && user && user.type === 'superadmin'
              "
            >
              <h4
                v-if="!edittitle_column1"
                class="
                  card-title
                  text-center
                  font-montserrat font-weight-bold
                  mb-3
                "
                @click="
                  !isEditing &&
                    toggleInput('edittitle_column1', 'city-title_column1-input')
                "
              >
                {{
                  editedTexts.columnsSection.title_column1.trim().length !== 0
                    ? editedTexts.columnsSection.title_column1
                    : '[Editar Texto]'
                }}
              </h4>
              <v-text-field
                v-show="edittitle_column1"
                ref="city-title_column1-input"
                v-model="editedTexts.columnsSection.title_column1"
                solo
                dense
                loader-height="6"
                dark
                :loading="loading"
                @keydown.enter.exact.prevent
                @keyup.enter.exact="updateLandingText"
                @blur="updateLandingText"
              />
            </template>
            <template v-else>
              <h4
                class="
                  card-title
                  text-center
                  font-montserrat font-weight-bold
                  mb-3
                "
              >
                {{ editedTexts.columnsSection.title_column1 }}
              </h4>
            </template>
            <!-- ColumnSection: Edición de Info Columna 1 -->
            <template
              v-if="
                $store.getters['loggedIn'] && user && user.type === 'superadmin'
              "
            >
              <p
                v-if="!editinfo_column1"
                class="card-content font-lato font-weight-regular text-center"
                @click="
                  !isEditing &&
                    toggleInput('editinfo_column1', 'city-infocol1-input')
                "
              >
                {{
                  editedTexts.columnsSection.info_column1.trim().length !== 0
                    ? editedTexts.columnsSection.info_column1
                    : '[Editar Texto]'
                }}
              </p>
              <v-textarea
                v-show="editinfo_column1"
                ref="city-infocol1-input"
                v-model="editedTexts.columnsSection.info_column1"
                solo
                dense
                loader-height="6"
                dark
                :loading="loading"
                @keydown.enter.exact.prevent
                @keyup.enter.exact="updateLandingText"
                @blur="updateLandingText"
              />
            </template>
            <template v-else>
              <p class="card-content font-lato font-weight-regular text-center">
                {{ editedTexts.columnsSection.info_column1 }}
              </p>
            </template>
          </v-card>
        </v-col>
        <v-col cols="12" md="4" class="mx-md-0">
          <v-card
            elevation="7"
            class="mx-lg-5 px-md-12 px-8 py-10 rounded-xl d-flex flex-column"
            height="100%"
          >
            <h2 class="text-center mb-3">
              <v-icon size="70"> $vuetify.icons.oscity_documentos </v-icon>
            </h2>
            <!-- ColumnSection: Edición de Titulo Columna 2 -->
            <template
              v-if="
                $store.getters['loggedIn'] && user && user.type === 'superadmin'
              "
            >
              <h4
                v-if="!edittitle_column2"
                class="
                  card-title
                  text-center
                  font-montserrat font-weight-bold
                  mb-3
                "
                @click="
                  !isEditing &&
                    toggleInput('edittitle_column2', 'city-title_column2-input')
                "
              >
                {{
                  editedTexts.columnsSection.title_column2.trim().length !== 0
                    ? editedTexts.columnsSection.title_column2
                    : '[Editar Texto]'
                }}
              </h4>
              <v-text-field
                v-show="edittitle_column2"
                ref="city-title_column2-input"
                v-model="editedTexts.columnsSection.title_column2"
                solo
                dense
                loader-height="6"
                dark
                :loading="loading"
                @keydown.enter.exact.prevent
                @keyup.enter.exact="updateLandingText"
                @blur="updateLandingText"
              />
            </template>
            <template v-else>
              <h4
                class="
                  card-title
                  text-center
                  font-montserrat font-weight-bold
                  mb-3
                "
              >
                {{ editedTexts.columnsSection.title_column2 }}
              </h4>
            </template>
            <!-- ColumnSection: Edición de Info Columna 2 -->
            <template
              v-if="
                $store.getters['loggedIn'] && user && user.type === 'superadmin'
              "
            >
              <p
                v-if="!editinfo_column2"
                class="card-content font-lato font-weight-regular text-center"
                @click="
                  !isEditing &&
                    toggleInput('editinfo_column2', 'city-infocol2-input')
                "
              >
                {{
                  editedTexts.columnsSection.info_column2.trim().length !== 0
                    ? editedTexts.columnsSection.info_column2
                    : '[Editar Texto]'
                }}
              </p>
              <v-textarea
                v-show="editinfo_column2"
                ref="city-infocol2-input"
                v-model="editedTexts.columnsSection.info_column2"
                solo
                dense
                loader-height="6"
                dark
                :loading="loading"
                @keydown.enter.exact.prevent
                @keyup.enter.exact="updateLandingText"
                @blur="updateLandingText"
              />
            </template>
            <template v-else>
              <p class="card-content font-lato font-weight-regular text-center">
                {{ editedTexts.columnsSection.info_column2 }}
              </p>
            </template>
          </v-card>
        </v-col>
        <v-col cols="12" md="4" class="mx-md-0">
          <v-card
            elevation="7"
            class="mx-lg-5 px-md-12 px-8 py-10 rounded-xl d-flex flex-column"
            height="100%"
          >
            <h2 class="text-center mb-3">
              <v-icon size="80"> $vuetify.icons.oscity_gobierno </v-icon>
            </h2>
            <!-- ColumnSection: Edición de Titulo Columna 3 -->
            <template
              v-if="
                $store.getters['loggedIn'] && user && user.type === 'superadmin'
              "
            >
              <h4
                v-if="!edittitle_column3"
                class="
                  card-title
                  text-center
                  font-montserrat font-weight-bold
                  mb-3
                "
                @click="
                  !isEditing &&
                    toggleInput('edittitle_column3', 'city-title_column3-input')
                "
              >
                {{
                  editedTexts.columnsSection.title_column3.trim().length !== 0
                    ? editedTexts.columnsSection.title_column3
                    : '[Editar Texto]'
                }}
              </h4>
              <v-text-field
                v-show="edittitle_column3"
                ref="city-title_column3-input"
                v-model="editedTexts.columnsSection.title_column3"
                solo
                dense
                loader-height="6"
                dark
                :loading="loading"
                @keydown.enter.exact.prevent
                @keyup.enter.exact="updateLandingText"
                @blur="updateLandingText"
              />
            </template>
            <template v-else>
              <h4
                class="
                  card-title
                  text-center
                  font-montserrat font-weight-bold
                  mb-3
                "
              >
                {{ editedTexts.columnsSection.title_column3 }}
              </h4>
            </template>
            <!-- ColumnSection: Edición de Info Columna 3 -->
            <template
              v-if="
                $store.getters['loggedIn'] && user && user.type === 'superadmin'
              "
            >
              <p
                v-if="!editinfo_column3"
                class="card-content font-lato font-weight-regular text-center"
                @click="
                  !isEditing &&
                    toggleInput('editinfo_column3', 'city-infocol3-input')
                "
              >
                {{
                  editedTexts.columnsSection.info_column3.trim().length !== 0
                    ? editedTexts.columnsSection.info_column3
                    : '[Editar Texto]'
                }}
              </p>
              <v-textarea
                v-show="editinfo_column3"
                ref="city-infocol3-input"
                v-model="editedTexts.columnsSection.info_column3"
                solo
                dense
                loader-height="6"
                dark
                :loading="loading"
                @keydown.enter.exact.prevent
                @keyup.enter.exact="updateLandingText"
                @blur="updateLandingText"
              />
            </template>
            <template v-else>
              <p class="card-content font-lato font-weight-regular text-center">
                {{ editedTexts.columnsSection.info_column3 }}
              </p>
            </template>
          </v-card>
        </v-col>
        <!-- </v-row>
      </v-col> -->
      </v-row>
      <v-row v-if="isDervinsa">
        <v-col xs="12" md="12" class="text-center">
          <v-flex xs12 class="text-center" mt-5>
            <h3 class="title-certificates">
              Encuentra aquí los certificados de nuestros procesos.
            </h3>
          </v-flex>
        </v-col>
        <v-col xs="12" md="12" class="d-flex justify-center">
          <v-flex xs8 mt-4 class="justify-center">
            <v-form
              ref="formCertificate"
              v-model="validCertificate"
              class="form-certificates"
              lazy-validation
              @submit.prevent="viewCertificate"
            >
              <v-autocomplete
                v-model="selectedCert"
                :items="items"
                :loading="isLoading"
                :rules="rules"
                item-text="text"
                item-value="ref"
                hide-details
                label="Certificados"
                placeholder="Buscar certificado por Mes o año"
                prepend-inner-icon="search"
                return-object
                required
                solo
              >
                <template slot="no-data">
                  <v-list-tile>
                    <v-list-tile-title>
                      Empieza a escribir para buscar por:
                      <strong>Mes año o tipo</strong>
                    </v-list-tile-title>
                  </v-list-tile>
                </template>
                <template slot="selection" slot-scope="{ item }">
                  <span v-text="item.text"></span>
                </template>
              </v-autocomplete>
              <v-flex xs12 class="text-center mt-4">
                <v-btn
                  :disabled="!selectedCert"
                  color="primary"
                  type="submit"
                  class="ma-0"
                >
                  Ver certificado
                </v-btn>
              </v-flex>
            </v-form>
          </v-flex>
        </v-col>
      </v-row>
    </v-container>
    <v-container
      v-if="projectID !== 'misiones-fondo-de-credito'"
      fluid
      class="py-12"
    >
      <v-row justify="center" align="center">
        <v-col cols="10">
          <v-row fill-height fluid class="mb-15">
            <v-col
              md="6"
              xs="12"
              align="center"
              justify="center"
              style="
                transform: translate3d(0px, 0px, 0px) scale3d(1, 1, 1)
                  rotateX(0deg) rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg);
                transform-style: preserve-3d;
              "
            >
              <template
                v-if="
                  $store.getters['loggedIn'] &&
                  user &&
                  user.type === 'superadmin'
                "
              >
                <v-img
                  max-height="500"
                  max-width="438"
                  :src="brandSettings.city_splash_secondary"
                  @click="!isEditing && toggleImageInput('editSecondaryImage')"
                ></v-img>

                <v-text-field
                  v-show="editSecondaryImage"
                  v-model="brandSettings.city_splash_secondary"
                  class="mt-1"
                  prepend-icon="mdi-image"
                  label="URL de Imagen Secundaria"
                  outline
                  solo
                  dense
                  dark
                  loader-height="4"
                  :loading="loading"
                  disabled
                  @keydown.enter.exact.prevent
                ></v-text-field>

                <v-row
                  v-show="editSecondaryImage"
                  justify="center"
                  class="mt-1"
                >
                  <v-col cols="3">
                    <input
                      v-show="false"
                      id="city_splash_secondary"
                      ref="city_splash_secondary"
                      type="file"
                      accept="image/*"
                      @change="onFileSelected"
                    />
                    <v-btn
                      block
                      color="primary"
                      title="Subir imagen"
                      @click="$refs.city_splash_secondary.click()"
                    >
                      <v-icon>mdi-cloud-upload</v-icon>
                    </v-btn>
                  </v-col>
                  <v-col cols="3">
                    <v-btn
                      block
                      color="primary"
                      title="Restaurar imagen por defecto"
                      @click="restoreSecondaryImage"
                    >
                      <v-icon>mdi-backup-restore</v-icon>
                    </v-btn>
                  </v-col>
                  <v-col cols="3">
                    <v-btn
                      block
                      color="primary"
                      title="Cancelar edición de imagen"
                      @click="toggleImageInput('editSecondaryImage')"
                    >
                      <v-icon>mdi-window-close</v-icon>
                    </v-btn>
                  </v-col>
                </v-row>
              </template>
              <template v-else>
                <v-img
                  max-height="500"
                  max-width="438"
                  class="image-splash"
                  :src="brandSettings.city_splash_secondary"
                ></v-img>
              </template>
            </v-col>
            <v-col
              md="6"
              xs="12"
              class="pa-12 d-flex align-content-center flex-wrap"
            >
              <v-row>
                <!-- Reminder: Edición de Reminder Title -->
                <template
                  v-if="
                    $store.getters['loggedIn'] &&
                    user &&
                    user.type === 'superadmin'
                  "
                >
                  <h3
                    v-if="!editReminderTitle"
                    class="
                      reminder-title
                      font-montserrat font-weight-bold
                      mb-5
                      text-left
                    "
                    @click="
                      !isEditing &&
                        toggleInput(
                          'editReminderTitle',
                          'city-reminderTitle-input'
                        )
                    "
                  >
                    {{
                      editedTexts.reminderSection.reminderTitle.trim()
                        .length !== 0
                        ? editedTexts.reminderSection.reminderTitle
                        : '[Editar Texto]'
                    }}
                  </h3>
                  <v-row>
                    <v-text-field
                      v-show="editReminderTitle"
                      ref="city-reminderTitle-input"
                      v-model="editedTexts.reminderSection.reminderTitle"
                      solo
                      dense
                      dark
                      loader-height="4"
                      :loading="loading"
                      @keydown.enter.exact.prevent
                      @keyup.enter.exact="updateLandingText"
                      @blur="updateLandingText"
                    />
                  </v-row>
                </template>
                <template v-else>
                  <h3
                    class="
                      reminder-title
                      font-montserrat font-weight-bold
                      mb-5
                      text-left
                    "
                  >
                    {{ editedTexts.reminderSection.reminderTitle }}
                  </h3>
                </template>
              </v-row>
              <!-- Reminder: Edición de Reminder Title -->
              <v-row align="center" justify="center">
                <template
                  v-if="
                    $store.getters['loggedIn'] &&
                    user &&
                    user.type === 'superadmin'
                  "
                >
                  <h4
                    v-if="!editReminderText"
                    class="
                      reminder-content
                      font-lato font-weight-light
                      edit
                      text-left
                    "
                    @click="
                      !isEditing &&
                        toggleInput(
                          'editReminderText',
                          'city-reminderText-input'
                        )
                    "
                  >
                    {{
                      editedTexts.reminderSection.reminderText.trim().length !==
                      0
                        ? editedTexts.reminderSection.reminderText
                        : '[Editar Texto]'
                    }}
                  </h4>
                  <v-row align="center" justify="center">
                    <v-textarea
                      v-show="editReminderText"
                      ref="city-reminderText-input"
                      v-model="editedTexts.reminderSection.reminderText"
                      solo
                      dense
                      dark
                      loader-height="4"
                      :loading="loading"
                      @keydown.enter.exact.prevent
                      @keyup.enter.exact="updateLandingText"
                      @blur="updateLandingText"
                    />
                  </v-row>
                </template>
                <template v-else>
                  <h4
                    class="
                      reminder-content
                      font-lato font-weight-light
                      text-left
                    "
                  >
                    {{ editedTexts.reminderSection.reminderText }}
                  </h4>
                </template>
              </v-row>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-container>
    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </section>
</template>

<script>
import Vue from 'vue'
import _ from 'lodash'
import { mapGetters, mapMutations } from 'vuex'

import { version } from '../package.json'
import { updateLandingText, getCertificates } from '~/services/LandingText'
import { updateBrand } from '~/services/Brand'

export default Vue.extend({
  components: {},
  props: {},
  data() {
    return {
      version,
      hero_dialog: false,
      imageUploadRules: [
        (value) =>
          !value ||
          value.type === 'image/jpeg' ||
          'El archivo debe tener una extensión de imágen válida.',
      ],
      backgroundTypes: [
        { type: 'lineal', text: this.$t('editor.linear_color') },
        { type: 'gradient', text: this.$t('editor.gradient_color') },
        { type: 'image', text: this.$t('editor.image') },
      ],
      isEditing: false,
      loading: false,
      editTitle: false,
      editSubtitle: false,
      editSecondSubtitle: false,
      editCityTitle: false,
      editCitySlogan: false,
      edittitle_column1: false,
      edittitle_column2: false,
      edittitle_column3: false,
      editinfo_column1: false,
      editinfo_column2: false,
      editinfo_column3: false,
      editReminderTitle: false,
      editReminderText: false,
      editcertificate_title: false,
      editPrimaryImage: false,
      editSecondaryImage: false,
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
      selectedCert: null,
      items: [],
      validCertificate: false,
      urlEndpoints: process.env.OSCITY_ENDPOINTS_URL,
      isDervinsa: process.env.FIREBASE_PROJECT_ID === 'dervinsa-6a138',
      isUnicef: process.env.FIREBASE_PROJECT_ID === 'unicef-certs',
      projectID: process.env.FIREBASE_PROJECT_ID,
      isLoading: false,
      rules: [(v) => !!v || 'El campo es requerido'],
      error: {
        hero_bg_image: false,
      },
    }
  },
  computed: {
    ...mapGetters({
      user: 'users/user',
      landingtext: 'landingtext/landingtext',
      brand: 'brand/brand',
    }),
    hero_background() {
      return this.brandSettings.hero_background_type === 'lineal'
        ? `background-color: ${this.brandSettings.hero_bg_primary}`
        : this.brandSettings.hero_background_type === 'gradient'
        ? `background-image: linear-gradient(to bottom, ${this.brandSettings.hero_bg_primary}, ${this.brandSettings.hero_bg_secondary}`
        : this.brandSettings.hero_background_type === 'image'
        ? `background-image: url(${this.brandSettings.hero_bg_image}); background-size: cover; background-position: center;`
        : 'background-image: linear-gradient(to bottom, #5d306f, #bd0b4d)'
    },
    editedTexts() {
      return _.cloneDeep(this.landingtext)
    },
    brandSettings() {
      return _.cloneDeep(this.brand)
    },
  },
  mounted() {
    console.info('CMP Version:', version)
    if (this.isDervinsa) {
      this.getDervinsaCerts()
    }
    this.$store.commit('SET_HOME_TOP', true)
  },
  methods: {
    ...mapMutations({
      setEditedTexts: 'landingtext/SET_LANDINGTEXT',
      setBrandSettings: 'brand/SET_BRAND',
    }),
    async getDervinsaCerts() {
      const self = this
      const result = await getCertificates(this.$fire)
      if (!result.empty) {
        result.docs.forEach((element) => {
          const data = {
            ref: element.ref.path,
            ...element.data(),
          }
          const searchText = data.acid.split('.pdf')[0].split('_').join(' ')
          data.text = searchText
          if (data.is_certified) {
            self.items.push(data)
          }
        })
        self.items.sort(function (a, b) {
          return (
            parseInt(a.acid.split('.pdf')[0].split('_')[3]) -
            parseInt(b.acid.split('.pdf')[0].split('_')[3])
          )
        })
      }
    },
    viewCertificate() {
      if (this.$refs.formCertificate.validate()) {
        window.open(this.selectedCert.link, '_blank')
      }
    },
    async updateBrand() {
      this.loading = true
      try {
        await updateBrand(this.$fire, this.brandSettings.id, this.brandSettings)
        this.clearStore()
        this.setBrandSettings(this.brandSettings)
      } catch {
        this.snackbar.show = true
        this.snackbar.text = 'No se pudo guardar la actualización'
        this.snackbar.color = 'error'
      }
      this.loading = false
      this.isEditing = false
      this.hero_dialog = false
    },
    onScroll(e) {
      if (
        e &&
        e.target &&
        e.target.scrollingElement &&
        e.target.scrollingElement.scrollTop >= 10
      ) {
        this.$store.commit('SET_HOME_TOP', false)
      } else {
        this.$store.commit('SET_HOME_TOP', true)
      }
    },
    async toggleInput(field, element) {
      this.isEditing = true
      this[field] = true
      await this.$nextTick()
      this.$refs[element].focus()
    },

    toggleImageInput(field) {
      this.isEditing = !this.isEditing
      this[field] = !this[field]
    },
    clearStore() {
      this.editTitle = false
      this.editSubtitle = false
      this.editSecondSubtitle = false
      this.editTitle = false
      this.editSubtitle = false
      this.editSecondSubtitle = false
      this.editCityTitle = false
      this.editCitySlogan = false
      this.edittitle_column1 = false
      this.edittitle_column2 = false
      this.edittitle_column3 = false
      this.editinfo_column1 = false
      this.editinfo_column2 = false
      this.editinfo_column3 = false
      this.editReminderTitle = false
      this.editReminderText = false
      this.editcertificate_title = false
      this.editPrimaryImage = false
    },
    async updateLandingText() {
      this.loading = true
      try {
        await updateLandingText(
          this.$fire,
          this.editedTexts.id,
          this.editedTexts
        )
        this.clearStore()
        this.setEditedTexts(this.editedTexts)
      } catch {
        this.snackbar.show = true
        this.snackbar.text = 'No se pudo guardar la actualización'
        this.snackbar.color = 'error'
      }
      this.loading = false
      this.isEditing = false
    },
    onFileSelected(event) {
      const self = this
      const storage = this.$fire.storage
      const target = event.target.id
      const file = event.target.files[0]
      const photosRef = storage.ref().child(`brand/images/${target}`)
      photosRef
        .put(file)
        .then((snapshot) => {
          snapshot.ref.getDownloadURL().then(function (downloadURL) {
            self.brandSettings[target] = downloadURL
          })
        })
        .catch((err) => {
          this.snackbar.show = true
          this.snackbar.text = err.message
          this.snackbar.color = 'error'
          this.$wait.end('full')
        })
      this.loading = false
      this.isEditing = false
    },
    imageReset(target) {
      this.error[target] = false
    },
    imageLoadError(target) {
      this.error[target] = true
    },
    restorePrimaryImage() {
      this.brandSettings.city_splash_primary =
        'https://firebasestorage.googleapis.com/v0/b/demosburg-dev.appspot.com/o/brand%2Fimages%2Fdefault_splash_primary.png?alt=media&token=b4feafa8-08ba-4396-9fc0-1fbbed2cf5e4'
      this.updateBrand()
    },
    restoreSecondaryImage() {
      this.brandSettings.city_splash_secondary =
        'https://firebasestorage.googleapis.com/v0/b/demosburg-dev.appspot.com/o/brand%2Fimages%2Fdefault_splash_secondary.png?alt=media&token=616244e7-e306-498a-a3b3-3d138c15f10f'
      this.updateBrand()
    },
  },
})
</script>

<style scoped>
.fill-brand__image {
  height: 100% !important;
  background-image: url('https://cdn.vuetifyjs.com/images/backgrounds/vbanner.jpg');
  background-size: cover;
  background-repeat: no-repeat;
}

.v-container.first {
  box-shadow: 0 8px 17px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
}
.v-parallax.first >>> .v-parallax__image {
  filter: brightness(45%);
}
.v-parallax.last {
  box-shadow: 0 8px 17px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
}
.v-parallax.last >>> .v-parallax__image {
  filter: brightness(45%);
}
.title-certificates {
  font-size: 30px;
}

.hero-title {
  font-size: 3.4375rem;
}

.hero-subtitle {
  font-size: 1.7em;
}

.hero-second-subtitle {
  font-size: 1.1em;
}

.hero-button {
  font-weight: 600;
  font-size: 0.875em;
}

.columnSection-slogan {
  font-size: 3.125em;
  color: #2a3042;
}

.card-title {
  font-size: 1.633125em;
  color: #303136;
}

.card-misiones-title {
  font-size: 3em;
  color: #303136;
}
.card-misiones {
  background: #002a61; /* Old browsers */
  background: -moz-linear-gradient(
    right,
    #0687cd 0%,
    #002a61 100%
  ); /* FF3.6-15 */
  background: -webkit-linear-gradient(
    right,
    #0687cd 0%,
    #002a61 100%
  ); /* Chrome10-25,Safari5.1-6 */
  background: linear-gradient(to right, #0687cd 0%, #002a61 100%);
}
.card-misiones-border {
  content: '';
  width: 18px;
  position: absolute;
  left: 0;
  top: 0;
  bottom: 0;
  background: #de0000; /* Old browsers */
  background: -moz-linear-gradient(
    top,
    #de0000 0%,
    #de0000 33%,
    #1069c7 33%,
    #1069c7 66%,
    #ffffff 66%,
    #ffffff 66%,
    #ffffff 100%
  ); /* FF3.6-15 */
  background: -webkit-linear-gradient(
    top,
    #de0000 0%,
    #de0000 33%,
    #1069c7 33%,
    #1069c7 66%,
    #ffffff 66%,
    #ffffff 66%,
    #ffffff 100%
  ); /* Chrome10-25,Safari5.1-6 */
  background: linear-gradient(
    to bottom,
    #de0000 0%,
    #de0000 33%,
    #1069c7 33%,
    #1069c7 66%,
    #ffffff 66%,
    #ffffff 66%,
    #ffffff 100%
  ); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
  filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#de0000', endColorstr='#ffffff',GradientType=0 ); /* IE6-9 */
}

.card-content {
  font-size: 1.125em;
  color: #757575;
}

.card-misiones-content {
  font-size: 1.25em;
  color: #757575;
}

.reminder-title {
  font-size: 3.4375em;
  line-height: 1;
  color: #2a3042;
}

.reminder-content {
  font-size: 2.125em;
  color: #2a3042;
}

.v-text-field >>> input {
  padding: 0 !important;
}

@media only screen and (max-width: 465px) {
  .hero-title {
    font-size: 2em;
  }
  .columnSection-slogan {
    font-size: 1.8em;
  }
  .reminder-title {
    font-size: 2em;
    text-align: center;
  }
  .reminder-content {
    font-size: 1.5em;
  }

  .card-title {
    font-size: 1.4em;
  }

  .card-content {
    font-size: 1em;
  }

  .card-misiones-title {
    font-size: 2.1em;
  }
}

@media (max-width: 400px) {
  .card-misiones-title {
    font-size: 2.1em;
  }
}
@media (min-width: 401px) and (max-width: 600px) {
  .card-misiones-title {
    font-size: 2.3em;
  }
}
@media (min-width: 600px) and (max-width: 730px) {
  .card-misiones-title {
    font-size: 2.5em;
  }
}

@media (max-width: 575px) {
  .hero-title {
    font-size: 11vw;
  }

  .reminder-title {
    font-size: 8vw;
  }
}

@media (min-width: 960px) and (max-width: 1264px) {
  .card-title {
    font-size: 1.2em;
  }
  .card-content {
    font-size: 1em;
  }
  .reminder-title {
    font-size: 4vw;
  }
}

@media (min-width: 1264px) and (max-width: 1330px) {
  .card-title {
    font-size: 1.2em;
  }
  .card-content {
    font-size: 1em;
  }
}

@media (min-width: 1330px) and (max-width: 1472px) {
  .card-title {
    font-size: 1.4em;
  }
  .card-content {
    font-size: 1em;
  }
}
</style>
